




### Multinomial Logit model estimation

### Create the data array from the existing dataset
Data <- read.csv("C:/Users/ysueki/Downloads/trip_toyosu2018_teamindb_rev_v8.csv")@@@###f[^
## Count the number of data rows
hh <- nrow(Data)

D0 <- subset(Data,Data$ړI=="ʋ΁Eʊw" )  #ʋΒʊwgbv̒o
D1 <- subset(D0,D0$mode2!="other")
D2 <- subset(D1,D1$LltO!=0)
#D2 <- subset(D2,D2$[U[R[h==4724)

## Recall that we estimate parameters by maximizing the log-likelihood function, hence we first need to define that function


## Set the initial values of the parameters (the number in parenthesis corresponds to the number of parameters to be estimated)
b0 <- numeric(6)@#ϐ


D2$N = as.numeric(as.character(D2$N))
D2$worker = 0
D2[D2$N<45 & D2$N >= 20,]$worker = 1



#D2$i_芷P <- as.numeric( as.character(D2$i_芷P))
#D2$i_芷P <- as.numeric( D2$i_芷P)
#D2$i_芷P <- as.numeric( D2$i_芷P)
#D2$i_芷P <- as.numeric( D2$i_芷P)
#D2$i_芷P <- as.numeric( D2$i_芷P)
##### Define the log-likelihood function of the logit model#####

fr <- function(x) {
  ### declare the parameters###
  ## Alternative specific constants
  
  # x <- numeric(6)
  
  ## Travel time to destination
  d1 <- x[1]
  d2 <- x[2]
  d3 <- x[3]
  d4 <- x[4]
  
  b1 <- x[5] #ړ
  b2 <- x[6] #20-45
  
  ## declare the log-likelihood variable, set value to 0
  LL = 0
  
  ### For this choice problem, we consider the following 6 modes???
  ## S(train)
  ## oX(bus)
  ## p(car)
  ## ^NV[(taxi)
  ## ](bike)
  ## k(walk)
  
  ## calculate the utility function: :introduce the desired explanatory variables in the function
  # time           # fare      # constant
  tri_1 <-  D2$i_芷P*exp(       b1*D2$֑I_ړ_芷1/1000 +b2*D2$worker   )
  tri_2 <- D2$i_芷2*exp(       b1*D2$֑I_ړ_芷2/1000 + d1*matrix(1,nrow(D2),1))
  tri_3 <- D2$i_芷3*exp(       b1*D2$֑I_ړ_芷3/1000 + d2*matrix(1,nrow(D2),1))
  tri_4 <- D2$i_芷4*exp(       b1*D2$֑I_ړ_芷4/1000 + d3*matrix(1,nrow(D2),1))
  tri_5 <- D2$i_芷5*exp(       b1*D2$֑I_ړ_芷5/1000 + d4*matrix(1,nrow(D2),1))
  
  ### Calculate the choice probabilities
  ## calculate the Inclusive Value (the denominator of the choice probabilities equation)
  deno <- (tri_1 + tri_2 + tri_3 + tri_4 + tri_5 )
  
  ## Calculate indiviudal choice probabilities
  Ptri_1 <-(tri_1/ deno)
  Ptri_2 <- (tri_2 / deno)
  Ptri_3 <- (tri_3 / deno)
  Ptri_4 <- (tri_4 / deno)
  Ptri_5 <- (tri_5 / deno)
  
  ## Avoid problems stemming from choice probabilities becoming zero.Im??????0ɂȂĂ܂???ɋN???
  Ptri_1 <- (Ptri_1!=0)*Ptri_1 + (Ptri_1==0)
  Ptri_2 <- (Ptri_2!=0)*Ptri_2 + (Ptri_2==0)
  Ptri_3 <- (Ptri_3!=0)*Ptri_3 + (Ptri_3==0)
  Ptri_4 <- (Ptri_4!=0)*Ptri_4 + (Ptri_4==0)
  Ptri_5 <- (Ptri_5!=0)*Ptri_5 + (Ptri_5==0)
  
  
  ## Choice results
  Ctri_1   <-  D2$kȊOiv ==1
  Ctri_2   <-  D2$kȊOiv ==2
  Ctri_3   <-  D2$kȊOiv ==3
  Ctri_4   <-  D2$kȊOiv ==4
  Ctri_5   <-  D2$kȊOiv ==5
  
  ## Calculate the Log-likelihood function
  LL <- colSums( Ctri_1*log(Ptri_1) +  Ctri_2*log(Ptri_2) +  Ctri_3*log(Ptri_3)   +  Ctri_4*log(Ptri_4) +  Ctri_5*log(Ptri_5) )
  
}

##### Maximize the Log-likelihood function#####

##Parameter optimization 
res <- optim(b0,fr,gr=NULL, method = "Nelder-Mead", hessian = TRUE, control=list(fnscale=-1))

## Parmeter estimationAHessian matrix calculation 
b   <- res$par
hhh <- res$hessian

## Calculate the t-statistic
tval <- b/sqrt(-diag(solve(hhh)))

## L(0), Log-Likelihood when all parameters are 0
L0 <- fr(b0)
## LL, maximium likelihood
LL <- res$value

##### Output #####
print(res)
## L(0)
print(L0)
## LL
print(LL)
##rho-square
print((L0-LL)/L0)
## adjusted rho-square
print((L0-(LL-length(b)))/L0)
##estimated parameter values
print(b)
## t-statistic 
print(tval)



###Im̌vZ####


fr1 <- function(x) {
  ### declare the parameters###
  ## Alternative specific constants
  
  # x <- numeric(6)
  
  ## Travel time to destination
  d1 <- x[1]
  d2 <- x[2]
  d3 <- x[3]
  d4 <- x[4]
  
  b1 <- x[5] #ړ
  b2 <- x[6] #20-45
  
  ## declare the log-likelihood variable, set value to 0
  LL = 0
  
  ### For this choice problem, we consider the following 6 modes???
  ## S(train)
  ## oX(bus)
  ## p(car)
  ## ^NV[(taxi)
  ## ](bike)
  ## k(walk)
  
  ## calculate the utility function: :introduce the desired explanatory variables in the function
  # time           # fare      # constant
  
  ## calculate the utility function: :introduce the desired explanatory variables in the function
  # time           # fare      # constant
  tri_1 <-  D2$i_芷P*exp(       b1*D2$֑I_ړ_芷1/1000 +b2*D2$worker   )
  tri_2 <- D2$i_芷2*exp(       b1*D2$֑I_ړ_芷2/1000 + d1*matrix(1,nrow(D2),1))
  tri_3 <- D2$i_芷3*exp(       b1*D2$֑I_ړ_芷3/1000 + d2*matrix(1,nrow(D2),1))
  tri_4 <- D2$i_芷4*exp(       b1*D2$֑I_ړ_芷4/1000 + d3*matrix(1,nrow(D2),1))
  tri_5 <- D2$i_芷5*exp(       b1*D2$֑I_ړ_芷5/1000 + d4*matrix(1,nrow(D2),1))
  
  ### Calculate the choice probabilities
  ## calculate the Inclusive Value (the denominator of the choice probabilities equation)
  deno <- (tri_1 + tri_2 + tri_3 + tri_4 + tri_5 )
  
  ## Calculate indiviudal choice probabilities
  Ptri_1 <-(tri_1/ deno)
  Ptri_2 <- (tri_2 / deno)
  Ptri_3 <- (tri_3 / deno)
  Ptri_4 <- (tri_4 / deno)
  Ptri_5 <- (tri_5 / deno)
  
  Output1 <- cbind(Ptri_1,Ptri_2,Ptri_3,Ptri_4,Ptri_5)
  colnames(Output1) <-c("Ptri_1","Ptri_2","Ptri_3","Ptri_4","Ptri_5")
 return(Output1) 
}

output1 <- fr1(b)
rowSums(output1)

###Im̌vZ####

mean(D2$֑I_ړ_芷1)
mean(D2$֑I_ړ_芷2)
mean(D2$֑I_ړ_芷3)
mean(D2$֑I_ړ_芷4)
mean(D2$֑I_ړ_芷5)

fr2 <- function(x) {
  ### declare the parameters###
  ## Alternative specific constants
  
  # x <- numeric(6)
  
  ## Travel time to destination
  d1 <- x[1]
  d2 <- x[2]
  d3 <- x[3]
  d4 <- x[4]
  
  b1 <- x[5] #ړ
  b2 <- x[6] #20-45
  
  ## declare the log-likelihood variable, set value to 0
  LL = 0
  
  ### For this choice problem, we consider the following 6 modes???
  ## S(train)
  ## oX(bus)
  ## p(car)
  ## ^NV[(taxi)
  ## ](bike)
  ## k(walk)
  
  ## calculate the utility function: :introduce the desired explanatory variables in the function
  # time           # fare      # constant
  
  ## calculate the utility function: :introduce the desired explanatory variables in the function
  # time           # fare      # constant
  tri_1 <-  D2$i_芷P*exp(       b1*D2$֑I_ړ_芷1/1000 +b2*D2$worker   )
  tri_2 <- D2$i_芷2*exp(       b1*D2$֑I_ړ_芷2/1000 + d1*matrix(1,nrow(D2),1))
  tri_3 <- D2$i_芷3*exp(       b1*D2$֑I_ړ_芷3/1000 + d2*matrix(1,nrow(D2),1))
  tri_4 <- D2$i_芷4*exp(       b1*D2$֑I_ړ_芷4/1000 + d3*matrix(1,nrow(D2),1))
  tri_5 <- D2$i_芷5*exp(       b1*D2$֑I_ړ_芷5/1000 + d4*matrix(1,nrow(D2),1))
  masu <-  exp(b1*4*D2$vkmȈՔ+b2*D2$worker)
  
  
  ### Calculate the choice probabilities
  ## calculate the Inclusive Value (the denominator of the choice probabilities equation)
  deno <- (tri_1 + tri_2 + tri_3 + tri_4 + tri_5 +  masu )
  
  ## Calculate indiviudal choice probabilities
  Ptri_1 <-(tri_1/ deno)
  Ptri_2 <- (tri_2 / deno)
  Ptri_3 <- (tri_3 / deno)
  Ptri_4 <- (tri_4 / deno)
  Ptri_5 <- (tri_5 / deno)
  Pmasu   <- (masu/deno)
  
  Output2 <- cbind(Ptri_1,Ptri_2,Ptri_3,Ptri_4,Ptri_5,Pmasu)
  colnames(Output2) <- c("Ptri_1","Ptri_2","Ptri_3","Ptri_4","Ptri_5","masu")
  return(Output2) 
}

output2 <- fr2(b)
rowSums(output2)
#######

output1 <- cbind(output1,D2$[U[R[h)
output2 <- cbind(output2,D2$[U[R[h)

write.csv(output1,"C:/Users/ysueki/Downloads/output1.csv")
write.csv(output2,"C:/Users/ysueki/Downloads/output2.csv")




